(* ****************************************************************************
 *                            AdjImgSize
 *                  Copyright (C) 1998-2004 Fumio Kawamata
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
 *  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
 *  Public License in the directory "gnu" for more details.
 ******************************************************************************
 *)
unit AdjImgSize;

interface
procedure AdjustImageSize(X1,Y1,X2,Y2:Integer; var X3,Y3:Integer);

implementation

procedure AdjustImageSize(X1,Y1,X2,Y2:Integer; var X3,Y3:Integer);
(* X1,Y1: Original image size
 * X2,Y2: Desired image size
 * X3,Y3: Adjusted image size
 *)
var
  AspectRatio : single;
  TmpX,TmpY : single;
begin
  if (X1<=X2)and(Y1<=Y2) then begin
    X3:=X1;
    Y3:=Y1;
    exit;
  end;
  AspectRatio:=X1/Y1;
  TmpX:=X2;
  TmpY:=TmpX/AspectRatio;
  if TmpY>Y2 then begin
    TmpY:=Y2;
    TmpX:=TmpY*AspectRatio;
  end;
  X3:=Trunc(TmpX);
  Y3:=Trunc(TmpY);
end;

end.
